Imports System.Data
Imports System.Data.OleDb
Public Class frmBooks
  Dim BooksConnection As OleDbConnection
  Dim SQLAll As String
  Dim btnRolodex(26) As Button


  Private Sub frmBooks_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    'connect to books database
    BooksConnection = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source = c:\VB2005DB\Working\books.mdb")
    BooksConnection.Open()
    'create Rolodex buttons for searching
    Dim W As Integer, LStart As Integer, L As Integer, T As Integer
    Dim ButtonHeight As Integer = 30 'found by trial and error
    Dim I As Integer
    'search buttons
    'determine button width (don't round up) - 13 on a row
    W = CInt(Me.ClientSize.Width / 14 - 0.5)
    'center buttons on form
    LStart = CInt(0.5 * (Me.ClientSize.Width - 13 * W))
    L = LStart
    T = grdBooks.Top + grdBooks.Height + 2
    'create and position 26 buttons
    For I = 1 To 26
      'create new pushbutton
      btnRolodex(I) = New Button()
      btnRolodex(I).TabStop = False
      'set text property
      btnRolodex(I).Text = Chr(64 + I)
      'position 
      btnRolodex(I).Width = W
      btnRolodex(I).Height = ButtonHeight
      btnRolodex(I).Left = L
      btnRolodex(I).Top = T
      'give cool colors
      btnRolodex(I).BackColor = Color.Blue
      btnRolodex(I).ForeColor = Color.White
      'add button to form
      Me.Controls.Add(btnRolodex(I))
      'add event handler
      AddHandler btnRolodex(I).Click, AddressOf Me.btnSQL_Click
      'next left
      L += W
      If I = 13 Then
        'move to next row
        L = LStart
        T = T + ButtonHeight
      End If
    Next I
    'Build basic SQL statement
    SQLAll = "SELECT Authors.Author,Titles.Title,Publishers.Company_Name "
    SQLAll += "FROM Authors, Titles, Publishers, Title_Author "
    SQLAll += "WHERE Titles.ISBN = Title_Author.ISBN "
    SQLAll += "AND Authors.Au_ID = Title_Author.Au_ID "
    SQLAll += "AND Titles.PubID = Publishers.PubID "
    'show form and click on all records initially
    Me.Show()
    btnAll.PerformClick()
  End Sub
  Private Sub frmBooks_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
    BooksConnection.Close()
    BooksConnection.Dispose()
  End Sub

  Private Sub btnSQL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAll.Click
    Dim ResultsCommand As OleDbCommand = Nothing
    Dim ResultsAdapter As New OleDbDataAdapter
    Dim ResultsTable As New DataTable
    Dim SQLStatement As String
    'determine which button was clicked and form SQL statement
    Dim ButtonClicked As Button
    ButtonClicked = CType(sender, Button)
    Select Case ButtonClicked.Text
      Case "Show All Records"
        SQLStatement = SQLAll
      Case "A" To "Y"
        'Letter key other than Z clicked
        'Append to SQLAll to limit records to letter clicked
        Dim Index As Integer = Asc(ButtonClicked.Text) - 64
        SQLStatement = SQLAll + "AND Authors.Author > '" + btnRolodex(Index).Text + " ' "
        SQLStatement += "AND Authors.Author < '" + btnRolodex(Index + 1).Text + " ' "
      Case Else
        'Z Clicked
        'Append to SQLAll to limit records to Z Authors
        SQLStatement = SQLAll + "AND Authors.Author > 'Z' "
    End Select
    SQLStatement += "ORDER BY Authors.Author"
    'apply SQL statement
    Try
      'establish command object and data adapter
      ResultsCommand = New OleDbCommand(SQLStatement, BooksConnection)
      ResultsAdapter.SelectCommand = ResultsCommand
      ResultsAdapter.Fill(ResultsTable)
      'bind grid view to data table
      grdBooks.DataSource = ResultsTable
    Catch ex As Exception
      MessageBox.Show(ex.Message, "Error in Processing SQL", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Try
    ResultsCommand.Dispose()
    ResultsAdapter.Dispose()
    ResultsTable.Dispose()
  End Sub
End Class
